<template>
  <div v-if="showPaymentInfo" class="order-step__payment-info">
    <h2 :class="{ active: isValid }" class="order-step-title">
      Платежная информация
      <i class="icon checked" />
    </h2>

    <ob-form
        :form-data="formData"
        :form-model="formModel"
        :is-show-controls="false"
        @validation="isValidForm = $event"
    >

      <div class="input-group">
        <div class="input-group-col">
          <ob-input
              v-model="formData.bik"
              label="БИК"
              required
              :is-dirty-force="!isManualEdited"
              :is-valid="isBIKValidServerCheck"
              mask="999999999"
              :mask-tokens="numberMaskTokens"
              property="bik"
              placeholder="Укажите БИК"
              data-qa="bik"
              @keyup.native="onBikEnter"
              @blur="updateInfo"
          />
          <ob-input
              v-model="formData.paymentAccount"
              label="Номер расчетного счета"
              required
              :is-dirty-force="!isManualEdited"
              :is-valid="isPaymentAccountValidServerCheck"
              mask="99999999999999999999"
              :mask-tokens="numberMaskTokens"
              property="paymentAccount"
              placeholder="Состоит из 20 цифр"
              data-qa="paymentAccount"
              @keyup.native="onPaymentAccountEnter"
              @blur="updateInfo"
          />
        </div>
        <template v-if="isBIKValidServerCheck">
          <div class="input-group-col">
            <ob-input
                v-model="unescapedBankName"
                label="Наименование банка"
                disabled
                placeholder=""
                data-qa="bankName"
            />
          </div>
          <div class="input-group-col">
            <ob-input
                v-model="paymentAccountData.paymentAccountInfo.ks"
                label="Корр. счет"
                disabled
                placeholder=""
                data-qa="ks"
            />
          </div>
        </template>
        <div v-if="isBIKValidLengthCheck && !isManualEdited && !isBIKValidServerCheck" class="bank-check-error">
          Не получается автоматически найти данные банка.
          Пожалуйста, свяжитесь со службой поддержки платформы ОБОЗ по телефону +7 (495) 646-06-03 или почте
          <a href="mailto:support@oboz.com">support@oboz.com</a>
        </div>
      </div>
    </ob-form>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import api from "@/api";
import obInput from 'common-components/src/obComponents/obInput';
import obForm from 'common-components/src/obComponents/obForm'
import required from "vuelidate/lib/validators/required";

export default {
  name: "paymentInfo",

  components: {
    obForm,
    obInput,
  },

  props: {
  },

  data() {
    return {
      formData: {
        bik: '',
        paymentAccount: ''
      },
      paymentAccountData: {
        haveMainAccount: true,
        paymentAccount: {
          bik: '',
          paymentAccount: ''
        },
        checkPaymentAccount: {
          isBIKValid: false,
          isPaymentAccountValid: false
        },
        paymentAccountInfo: {
          ks: '',
          bankName: ''
        }
      },
      paymentAccountCheck: {
        isBIKValid: false,
        isPaymentAccountValid: false
      },
      unescapedBankName: '',
      previousBik: '',
      isManualEdited: true,
      numberMaskTokens: {
        '0': { pattern: /\d/ },
      }
    }
  },

  computed: {
    ...mapGetters({
      order: 'order/order',
      isClient: 'user/isClient'
    }),

    formModel() {
      return {
        bik: {
          value: '',
          validator: {
            required,
            serverCheck: {
              method: () => this.isBIKValidServerCheck,
              error: ''
            }
          }
        },
        paymentAccount: {
          value: '',
          validator: {
            required,
            serverCheck: {
              method: () => this.isPaymentAccountValidServerCheck,
              error: 'Введенный номер не подходит. Проверьте, что номер из 20 цифр введен верно'
            }
          }
        }
      }
    },

    showPaymentInfo() {
      return this.isClient && !this.paymentAccountData.haveMainAccount;
    },

    isValid() {
      return this.isBIKValid && this.isPaymentAccountValid;
    },

    isBIKValid() {
      return this.isManualEdited ? this.isBIKValidLengthCheck === true : this.isBIKValidServerCheck === true;
    },

    isBIKValidServerCheck() {
      return this.paymentAccountData.checkPaymentAccount.isBIKValid === true;
    },

    isBikNotEmpty() {
      return this.formData.bik ? this.formData.bik.length > 0 : false;
    },

    isBIKValidLengthCheck() {
      return this.formData.bik ? this.formData.bik.length === 9 : false;
    },

    isPaymentAccountValid() {
      return this.isManualEdited ? this.isPaymentAccountValidLengthCheck === true : this.isPaymentAccountValidServerCheck === true;
    },

    isPaymentAccountValidServerCheck() {
      return this.paymentAccountData.checkPaymentAccount.isPaymentAccountValid === true;
    },

    isPaymentAccountNotEmpty() {
      return this.formData.paymentAccount ? this.formData.paymentAccount.length > 0 : false;
    },

    isPaymentAccountValidLengthCheck() {
      return this.formData.paymentAccount ? this.formData.paymentAccount.length === 20 : false;
    },
  },

  watch: {},

  async mounted() {
    if (this.isClient) {
      await this.fetchPaymentAccount();
      if (this.isBikNotEmpty || this.isPaymentAccountNotEmpty) {
        this.isManualEdited = false;
      }
    } else {
      this.emitShowPaymentInfo();
    }
  },

  methods: {
    async fetchPaymentAccount() {
      try {
        const { data } = await api.orders.fetchPaymentAccount(this.$route.params.id);
        this.paymentAccountData = data;

        this.unescapeBankName();
        this.previousBik = data.paymentAccount.bik || '';
        this.formData.bik = data.paymentAccount.bik || '';
        this.formData.paymentAccount = data.paymentAccount.paymentAccount || '';

        this.emitShowPaymentInfo();
        this.emitIsValidPaymentInfo();

      } catch (e) {
        this.onError();
        console.error(e);
      }
    },

    unescapeBankName() {
      let div = document.createElement('div');
      div.innerHTML = this.paymentAccountData.paymentAccountInfo.bankName;
      this.$set(this, 'unescapedBankName', div.textContent);
      div = null;
    },

    async savePaymentAccount() {
      try {
        const { data } = await api.orders.savePaymentAccount(this.$route.params.id, {
          bik: this.formData.bik,
          paymentAccount: this.formData.paymentAccount
        });
        this.$set(this.paymentAccountData.checkPaymentAccount, "isBIKValid", data.isBIKValid);
        this.$set(this.paymentAccountData.checkPaymentAccount, "isPaymentAccountValid", data.isPaymentAccountValid);

        this.isManualEdited = false;
        this.emitIsValidPaymentInfo();

        if (this.previousBik !== this.formData.bik) {
          this.fetchPaymentAccount();
        }
      } catch (e) {
        this.onError();
        console.error(e);
      }
    },

    onError() {
      this.$set(this.paymentAccountData.checkPaymentAccount, "isBIKValid", false);
      this.$set(this.paymentAccountData.checkPaymentAccount, "isPaymentAccountValid", false);
      this.isManualEdited = false;

      this.emitShowPaymentInfo();
      this.emitIsValidPaymentInfo();
    },

    async updateInfo() {
      if (this.isBIKValid || this.isPaymentAccountValid) {
        this.savePaymentAccount();
      }
    },

    onBikEnter() {
      this.isManualEdited = true;
    },

    onPaymentAccountEnter() {
      this.isManualEdited = true;
    },

    emitShowPaymentInfo() {
      this.$nextTick(() => {
        this.$emit("showPaymentInfo", this.showPaymentInfo);
      })
    },

    emitIsValidPaymentInfo() {
      this.$nextTick(() => {
        this.$emit("isValidPaymentInfo", this.isValid);
      })
    },
  },
}
</script>

<style scoped lang="scss">
.order-step__payment-info {
  margin-top: 36px;
}

.input-group {
  display: flex;
  margin-bottom: 24px;
  margin-top: 24px;

  .input-group-col {
    width: 33%;

    & + .input-group-col {
      margin-left: 20px;
    }

    .ob-input-container + .ob-input-container {
      margin-top: 10px;
    }
  }
}

.bank-check-error {
  font-size: 14px;
  line-height: 18px;
  color: $color-error;
  padding: 10px 0;
  margin-left: 20px;
  width: 66%;

  a {
    color: #0070a6;
    text-decoration: none;
  }
}
</style>